/*!
 * A lightweight, dependency-free and responsive javascript plugin for particle backgrounds.
 * 
 * @author Marc Bruederlin <hello@marcbruederlin.com>
 * @version 2.0.1
 * @license MIT
 * @see https://github.com/marcbruederlin/particles.js
 */
var Particles=function(t,e){"use strict";var i,o={};return i=function(){function t(){var t=this;t.defaults={responsive:null,selector:null,maxParticles:100,sizeVariations:3,speed:.5,color:t._hex2rgb("#000000"),minDistance:120,connectParticles:!1},t.element=null,t.context=null,t.ratio=null,t.breakpoints=[],t.activeBreakpoint=null,t.breakpointSettings=[],t.originalSettings=null,t.storage=[]}return t}(),i.prototype.init=function(t){var e=this;t.color=e._hex2rgb(t.color),e.options=e._extend(e.defaults,t),e.originalSettings=JSON.parse(JSON.stringify(e.options)),e._initializeCanvas(),e._initializeEvents(),e._registerBreakpoints(),e._checkResponsive(),e._initializeStorage(),e._animate()},i.prototype._initializeCanvas=function(){var i,o,n=this;return n.options.selector?(n.element=e.querySelector(n.options.selector),n.context=n.element.getContext("2d"),i=t.devicePixelRatio||1,o=n.context.webkitBackingStorePixelRatio||n.context.mozBackingStorePixelRatio||n.context.msBackingStorePixelRatio||n.context.oBackingStorePixelRatio||n.context.backingStorePixelRatio||1,n.ratio=i/o,n.element.width=t.innerWidth*n.ratio,n.element.height=t.innerHeight*n.ratio,n.element.style.width="100%",n.element.style.height="100%",void n.context.scale(n.ratio,n.ratio)):(console.warn("particles.js: No selector specified! Check https://github.com/marcbruederlin/particles.js#options"),!1)},i.prototype._initializeEvents=function(){var e=this;t.addEventListener("resize",e._resize.bind(e),!1)},i.prototype._initializeStorage=function(){var t=this;t.storage=[];for(var e=t.options.maxParticles;e--;)t.storage.push(new o(t.context,t.options))},i.prototype._registerBreakpoints=function(){var t,e,i,o=this,n=o.options.responsive||null;if("object"==typeof n&&null!==n&&n.length){for(t in n)if(i=o.breakpoints.length-1,e=n[t].breakpoint,n.hasOwnProperty(t)){for(n[t].options.color&&(n[t].options.color=o._hex2rgb(n[t].options.color));i>=0;)o.breakpoints[i]&&o.breakpoints[i]===e&&o.breakpoints.splice(i,1),i--;o.breakpoints.push(e),o.breakpointSettings[e]=n[t].options}o.breakpoints.sort(function(t,e){return e-t})}},i.prototype._checkResponsive=function(){var e,i=this,o=!1,n=t.innerWidth;if(i.options.responsive&&i.options.responsive.length&&null!==i.options.responsive){o=null;for(e in i.breakpoints)i.breakpoints.hasOwnProperty(e)&&n<=i.breakpoints[e]&&(o=i.breakpoints[e]);null!==o?(i.activeBreakpoint=o,i.options=i._extend(i.options,i.breakpointSettings[o])):null!==i.activeBreakpoint&&(i.activeBreakpoint=null,o=null,i.options=i._extend(i.options,i.originalSettings))}},i.prototype._refresh=function(){var t=this;t._initializeStorage(),t._update()},i.prototype._resize=function(){var e=this;e.element.width=t.innerWidth*e.ratio,e.element.height=t.innerHeight*e.ratio,e.context.scale(e.ratio,e.ratio),clearTimeout(e.windowDelay),e.windowDelay=t.setTimeout(function(){e._checkResponsive(),e._refresh()},50)},i.prototype._animate=function(){var e=this;e._draw(),t.requestAnimFrame(e._animate.bind(e))},i.prototype._draw=function(){var t=this;t.context.clearRect(0,0,t.element.width,t.element.height);for(var e=t.storage.length;e--;){var i=t.storage[e];i._draw()}t._update()},i.prototype._update=function(){for(var e=this,i=e.storage.length;i--;){var o=e.storage[i];if(o.x+=o.vx,o.y+=o.vy,o.x+o.radius>t.innerWidth?o.x=o.radius:o.x-o.radius<0&&(o.x=t.innerWidth-o.radius),o.y+o.radius>t.innerHeight?o.y=o.radius:o.y-o.radius<0&&(o.y=t.innerHeight-o.radius),e.options.connectParticles)for(var n=i+1;n<e.storage.length;n++){var r=e.storage[n];e._calculateDistance(o,r)}}},i.prototype._calculateDistance=function(t,e){var i,o=this,n=t.x-e.x,r=t.y-e.y;i=Math.sqrt(n*n+r*r),i<=o.options.minDistance&&(o.context.beginPath(),o.context.strokeStyle="rgba("+o.options.color.r+", "+o.options.color.g+", "+o.options.color.b+", "+(1.2-i/o.options.minDistance)+")",o.context.moveTo(t.x,t.y),o.context.lineTo(e.x,e.y),o.context.stroke(),o.context.closePath())},i.prototype._extend=function(t,e){return Object.keys(e).forEach(function(i){t[i]=e[i]}),t},i.prototype._hex2rgb=function(t){var e=/^#?([a-f\d]{2})([a-f\d]{2})([a-f\d]{2})$/i.exec(t);return e?{r:parseInt(e[1],16),g:parseInt(e[2],16),b:parseInt(e[3],16)}:null},o=function(e,i){var o=this;o.context=e,o.options=i,o.x=Math.random()*t.innerWidth,o.y=Math.random()*t.innerHeight,o.vx=Math.random()*o.options.speed*2-o.options.speed,o.vy=Math.random()*o.options.speed*2-o.options.speed,o.radius=Math.random()*Math.random()*o.options.sizeVariations,o._draw()},o.prototype._draw=function(){var t=this;t.context.fillStyle="rgb("+t.options.color.r+", "+t.options.color.g+", "+t.options.color.b+")",t.context.beginPath(),t.context.arc(t.x,t.y,t.radius,0,2*Math.PI,!1),t.context.fill()},t.requestAnimFrame=function(){return t.requestAnimationFrame||t.webkitRequestAnimationFrame||t.mozRequestAnimationFrame||function(e){t.setTimeout(e,1e3/60)}}(),new i}(window,document);!function(){"use strict";"function"==typeof define&&define.amd?define("Particles",function(){return Particles}):"undefined"!=typeof module&&module.exports?module.exports=Particles:window.Particles=Particles}();